'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function () {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    // default options:
    // {
    //     elem: '_',
    //     mod: '__',
    //     wordPattern: '[a-z0-9]+(?:-[a-z0-9]+)*'
    // }
    var bemNaming = (0, _bemNaming2.default)(options);
    var entityHook = options.entityHook || defaultEntityHook;

    return function (chai) {
        var Assertion = chai.Assertion;


        Assertion.addProperty('validBlock', (0, _block.blockProperty)(bemNaming, chai, entityHook));
        Assertion.addProperty('validElem', (0, _elem.elemProperty)(bemNaming, chai, entityHook));
        Assertion.addMethod('block', (0, _block.blockMethod)(bemNaming, chai, entityHook));
        Assertion.addMethod('elem', (0, _elem.elemMethod)(bemNaming, chai, entityHook));
        Assertion.addMethod('mods', (0, _mods.modsMethod)(bemNaming, chai, entityHook));
        Assertion.addMethod('bem', (0, _bemjson.bemjsonMethod)(bemNaming, chai, entityHook));
        Assertion.addMethod('bemjson', (0, _bemjson.bemjsonMethod)(bemNaming, chai, entityHook));
    };
};

var _bemNaming = require('bem-naming');

var _bemNaming2 = _interopRequireDefault(_bemNaming);

var _block = require('./block');

var _elem = require('./elem');

var _mods = require('./mods');

var _bemjson = require('./bemjson');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultEntityHook = function defaultEntityHook(entity) {
    return entity;
};